diff --git a/src/backend/utils/adt/timestamp.c b/src/backend/utils/adt/timestamp.c
index 0b385fd72c..23d43094e8 100644
--- a/src/backend/utils/adt/timestamp.c
+++ b/src/backend/utils/adt/timestamp.c
@@ -18,7 +18,6 @@
 #include <ctype.h>
 #include <math.h>
 #include <limits.h>
-#include <float.h>
 #include <sys/time.h>
 
 #include "access/xact.h"
@@ -74,16 +73,16 @@ typedef struct
 } generate_series_timestamptz_fctx;
 
 /*
- * The transition datatype for interval aggregates is declared as Internal. It's
- * a pointer to a IntervalAggState allocated in the aggregate context.
+ * The transition datatype for interval aggregates is declared as internal.
+ * It's a pointer to an IntervalAggState allocated in the aggregate context.
  */
 typedef struct IntervalAggState
 {
-	int64		N;				/* count of processed intervals */
-	Interval	sumX;			/* sum of processed intervals */
+	int64		N;				/* count of finite intervals processed */
+	Interval	sumX;			/* sum of finite intervals processed */
 	/* These counts are *not* included in N!  Use IA_TOTAL_COUNT() as needed */
-	int64		pInfcount;		/* count of +Inf values */
-	int64		nInfcount;		/* count of -Inf values */
+	int64		pInfcount;		/* count of +infinity intervals */
+	int64		nInfcount;		/* count of -infinity intervals */
 } IntervalAggState;
 
 #define IA_TOTAL_COUNT(ia) \
@@ -96,11 +95,12 @@ static bool AdjustIntervalForTypmod(Interval *interval, int32 typmod,
 static TimestampTz timestamp2timestamptz(Timestamp timestamp);
 static Timestamp timestamptz2timestamp(TimestampTz timestamp);
 
-static void interval_um_internal(Interval *interval, Interval *result);
-static void finite_interval_pl(Interval *result, Interval *span1,
-							   Interval *span2);
-static void finite_interval_mi(Interval *result, Interval *span1,
-							   Interval *span2);
+static void EncodeSpecialInterval(const Interval *interval, char *str);
+static void interval_um_internal(const Interval *interval, Interval *result);
+static void finite_interval_pl(const Interval *span1, const Interval *span2,
+							   Interval *result);
+static void finite_interval_mi(const Interval *span1, const Interval *span2,
+							   Interval *result);
 
 /* common code for timestamptypmodin and timestamptztypmodin */
 static int32
@@ -1604,8 +1604,8 @@ EncodeSpecialTimestamp(Timestamp dt, char *str)
 		elog(ERROR, "invalid argument for EncodeSpecialTimestamp");
 }
 
-void
-EncodeSpecialInterval(Interval *interval, char *str)
+static void
+EncodeSpecialInterval(const Interval *interval, char *str)
 {
 	if (INTERVAL_IS_NOBEGIN(interval))
 		strcpy(str, EARLY);
@@ -2101,6 +2101,13 @@ itm2interval(struct pg_itm *itm, Interval *span)
 /* itmin2interval()
  * Convert a pg_itm_in structure to an Interval.
  * Returns 0 if OK, -1 on overflow.
+ *
+ * Note: if the result is infinite, it is not treated as an overflow.  This
+ * avoids any dump/reload hazards from pre-17 databases that do not support
+ * infinite intervals, but do allow finite intervals with all fields set to
+ * INT_MIN/INT_MAX (outside the documented range).  Such intervals will be
+ * silently converted to +/-infinity.  This may not be ideal, but seems
+ * preferable to failure, and ought to be pretty unlikely in practice.
  */
 int
 itmin2interval(struct pg_itm_in *itm_in, Interval *span)
@@ -2112,8 +2119,6 @@ itmin2interval(struct pg_itm_in *itm_in, Interval *span)
 	span->month = (int32) total_months;
 	span->day = itm_in->tm_mday;
 	span->time = itm_in->tm_usec;
-	if (INTERVAL_NOT_FINITE(span))
-		return -1;
 	return 0;
 }
 
@@ -2280,29 +2285,6 @@ timestamp_fastcmp(Datum x, Datum y, SortSupport ssup)
 }
 #endif
 
-double
-interval2timestamp_no_overflow(Interval *interval)
-{
-	double		result;
-
-	if (INTERVAL_IS_NOBEGIN(interval))
-		result = -DBL_MAX;
-	else if (INTERVAL_IS_NOEND(interval))
-		result = DBL_MAX;
-	else
-	{
-		/*
-		 * Convert the month part of Interval to days using assumed average
-		 * month length of 365.25/12.0 days.  Not too accurate, but plenty
-		 * good enough for our purposes.
-		 */
-		return interval->time + interval->day * (double) USECS_PER_DAY +
-			interval->month * ((DAYS_PER_YEAR / (double) MONTHS_PER_YEAR) * USECS_PER_DAY);
-	}
-
-	return result;
-}
-
 Datum
 timestamp_sortsupport(PG_FUNCTION_ARGS)
 {
@@ -2526,6 +2508,15 @@ interval_cmp_internal(const Interval *interval1, const Interval *interval2)
 	return int128_compare(span1, span2);
 }
 
+static int
+interval_sign(const Interval *interval)
+{
+	INT128		span = interval_cmp_value(interval);
+	INT128		zero = int64_to_int128(0);
+
+	return int128_compare(span, zero);
+}
+
 Datum
 interval_eq(PG_FUNCTION_ARGS)
 {
@@ -2801,14 +2792,14 @@ timestamp_mi(PG_FUNCTION_ARGS)
 	/*
 	 * Subtracting two infinite timestamps with different signs results in an
 	 * infinite interval with the same sign as the left operand. Subtracting
-	 * two infinte timestamps with the same sign results in an error.
+	 * two infinite timestamps with the same sign results in an error.
 	 */
 	if (TIMESTAMP_IS_NOBEGIN(dt1))
 	{
 		if (TIMESTAMP_IS_NOBEGIN(dt2))
 			ereport(ERROR,
 					(errcode(ERRCODE_DATETIME_VALUE_OUT_OF_RANGE),
-					 errmsg("timestamp out of range")));
+					 errmsg("interval out of range")));
 		else
 			INTERVAL_NOBEGIN(result);
 	}
@@ -2817,7 +2808,7 @@ timestamp_mi(PG_FUNCTION_ARGS)
 		if (TIMESTAMP_IS_NOEND(dt2))
 			ereport(ERROR,
 					(errcode(ERRCODE_DATETIME_VALUE_OUT_OF_RANGE),
-					 errmsg("timestamp out of range")));
+					 errmsg("interval out of range")));
 		else
 			INTERVAL_NOEND(result);
 	}
@@ -3068,16 +3059,16 @@ timestamp_pl_interval(PG_FUNCTION_ARGS)
 	Timestamp	result;
 
 	/*
-	 * Adding two infinites with the same sign results in an infinite
-	 * timestamp with the same sign. Adding two infintes with different signs
-	 * results in an error.
+	 * Adding two infinities with the same sign results in an infinite
+	 * timestamp with the same sign. Adding two infinities with different
+	 * signs results in an error.
 	 */
 	if (INTERVAL_IS_NOBEGIN(span))
 	{
 		if (TIMESTAMP_IS_NOEND(timestamp))
 			ereport(ERROR,
 					(errcode(ERRCODE_DATETIME_VALUE_OUT_OF_RANGE),
-					 errmsg("interval out of range")));
+					 errmsg("timestamp out of range")));
 		else
 			TIMESTAMP_NOBEGIN(result);
 	}
@@ -3086,7 +3077,7 @@ timestamp_pl_interval(PG_FUNCTION_ARGS)
 		if (TIMESTAMP_IS_NOBEGIN(timestamp))
 			ereport(ERROR,
 					(errcode(ERRCODE_DATETIME_VALUE_OUT_OF_RANGE),
-					 errmsg("interval out of range")));
+					 errmsg("timestamp out of range")));
 		else
 			TIMESTAMP_NOEND(result);
 	}
@@ -3197,16 +3188,16 @@ timestamptz_pl_interval_internal(TimestampTz timestamp,
 	int			tz;
 
 	/*
-	 * Adding two infinites with the same sign results in an infinite
-	 * timestamp with the same sign. Adding two infintes with different signs
-	 * results in an error.
+	 * Adding two infinities with the same sign results in an infinite
+	 * timestamp with the same sign. Adding two infinities with different
+	 * signs results in an error.
 	 */
 	if (INTERVAL_IS_NOBEGIN(span))
 	{
 		if (TIMESTAMP_IS_NOEND(timestamp))
 			ereport(ERROR,
 					(errcode(ERRCODE_DATETIME_VALUE_OUT_OF_RANGE),
-					 errmsg("interval out of range")));
+					 errmsg("timestamp out of range")));
 		else
 			TIMESTAMP_NOBEGIN(result);
 	}
@@ -3215,7 +3206,7 @@ timestamptz_pl_interval_internal(TimestampTz timestamp,
 		if (TIMESTAMP_IS_NOBEGIN(timestamp))
 			ereport(ERROR,
 					(errcode(ERRCODE_DATETIME_VALUE_OUT_OF_RANGE),
-					 errmsg("interval out of range")));
+					 errmsg("timestamp out of range")));
 		else
 			TIMESTAMP_NOEND(result);
 	}
@@ -3362,16 +3353,12 @@ timestamptz_mi_interval_at_zone(PG_FUNCTION_ARGS)
 
 /* Negates the given interval */
 static void
-interval_um_internal(Interval *interval, Interval *result)
+interval_um_internal(const Interval *interval, Interval *result)
 {
 	if (INTERVAL_IS_NOBEGIN(interval))
 		INTERVAL_NOEND(result);
 	else if (INTERVAL_IS_NOEND(interval))
 		INTERVAL_NOBEGIN(result);
-	else if (interval->time == PG_INT64_MIN || interval->day == PG_INT32_MIN || interval->month == PG_INT32_MIN)
-		ereport(ERROR,
-				(errcode(ERRCODE_DATETIME_VALUE_OUT_OF_RANGE),
-				 errmsg("interval out of range")));
 	else
 	{
 		result->time = -interval->time;
@@ -3438,8 +3425,8 @@ interval_pl(PG_FUNCTION_ARGS)
 
 	/*
 	 * Adding two infinite intervals with the same signs results in an
-	 * infinite interval with the same sign. Adding two infinte intervals with
-	 * different signs results in an error.
+	 * infinite interval with the same sign. Adding two infinite intervals
+	 * with different signs results in an error.
 	 */
 	if (INTERVAL_IS_NOBEGIN(span1))
 	{
@@ -3462,7 +3449,7 @@ interval_pl(PG_FUNCTION_ARGS)
 	else if (INTERVAL_NOT_FINITE(span2))
 		memcpy(result, span2, sizeof(Interval));
 	else
-		finite_interval_pl(result, span1, span2);
+		finite_interval_pl(span1, span2, result);
 
 	PG_RETURN_INTERVAL_P(result);
 }
@@ -3479,7 +3466,7 @@ interval_mi(PG_FUNCTION_ARGS)
 	/*
 	 * Subtracting two infinite intervals with different signs results in an
 	 * infinite interval with the same sign as the left operand. Subtracting
-	 * two infinte intervals with the same sign results in an error.
+	 * two infinite intervals with the same sign results in an error.
 	 */
 	if (INTERVAL_IS_NOBEGIN(span1))
 	{
@@ -3504,7 +3491,7 @@ interval_mi(PG_FUNCTION_ARGS)
 	else if (INTERVAL_IS_NOEND(span2))
 		INTERVAL_NOBEGIN(result);
 	else
-		finite_interval_mi(result, span1, span2);
+		finite_interval_mi(span1, span2, result);
 
 	PG_RETURN_INTERVAL_P(result);
 }
@@ -3552,13 +3539,11 @@ interval_mul(PG_FUNCTION_ARGS)
 	}
 	else if (isinf(factor))
 	{
-		Interval	zero;
 		int			factor_sign,
 					result_sign;
 
 		factor_sign = factor >= 0.0 ? 1 : -1;
-		memset(&zero, 0, sizeof(zero));
-		result_sign = interval_cmp_internal(span, &zero) * factor_sign;
+		result_sign = interval_sign(span) * factor_sign;
 
 		if (result_sign == 0)
 			ereport(ERROR,
@@ -3740,11 +3725,21 @@ in_range_timestamptz_interval(PG_FUNCTION_ARGS)
 	bool		less = PG_GETARG_BOOL(4);
 	TimestampTz sum;
 
-	if (int128_compare(interval_cmp_value(offset), int64_to_int128(0)) < 0)
+	if (interval_sign(offset) < 0)
 		ereport(ERROR,
 				(errcode(ERRCODE_INVALID_PRECEDING_OR_FOLLOWING_SIZE),
 				 errmsg("invalid preceding or following size in window function")));
 
+	/*
+	 * Deal with cases where both base and offset are infinite, and computing
+	 * base +/- offset would cause an error.  As for float and numeric types,
+	 * we assume that all values infinitely precede +infinity and infinitely
+	 * follow -infinity.  See in_range_float8_float8() for reasoning.
+	 */
+	if (INTERVAL_IS_NOEND(offset) &&
+		(sub ? TIMESTAMP_IS_NOEND(base) : TIMESTAMP_IS_NOBEGIN(base)))
+		PG_RETURN_BOOL(true);
+
 	/* We don't currently bother to avoid overflow hazards here */
 	if (sub)
 		sum = timestamptz_mi_interval_internal(base, offset, NULL);
@@ -3767,11 +3762,21 @@ in_range_timestamp_interval(PG_FUNCTION_ARGS)
 	bool		less = PG_GETARG_BOOL(4);
 	Timestamp	sum;
 
-	if (int128_compare(interval_cmp_value(offset), int64_to_int128(0)) < 0)
+	if (interval_sign(offset) < 0)
 		ereport(ERROR,
 				(errcode(ERRCODE_INVALID_PRECEDING_OR_FOLLOWING_SIZE),
 				 errmsg("invalid preceding or following size in window function")));
 
+	/*
+	 * Deal with cases where both base and offset are infinite, and computing
+	 * base +/- offset would cause an error.  As for float and numeric types,
+	 * we assume that all values infinitely precede +infinity and infinitely
+	 * follow -infinity.  See in_range_float8_float8() for reasoning.
+	 */
+	if (INTERVAL_IS_NOEND(offset) &&
+		(sub ? TIMESTAMP_IS_NOEND(base) : TIMESTAMP_IS_NOBEGIN(base)))
+		PG_RETURN_BOOL(true);
+
 	/* We don't currently bother to avoid overflow hazards here */
 	if (sub)
 		sum = DatumGetTimestamp(DirectFunctionCall2(timestamp_mi_interval,
@@ -3798,11 +3803,21 @@ in_range_interval_interval(PG_FUNCTION_ARGS)
 	bool		less = PG_GETARG_BOOL(4);
 	Interval   *sum;
 
-	if (int128_compare(interval_cmp_value(offset), int64_to_int128(0)) < 0)
+	if (interval_sign(offset) < 0)
 		ereport(ERROR,
 				(errcode(ERRCODE_INVALID_PRECEDING_OR_FOLLOWING_SIZE),
 				 errmsg("invalid preceding or following size in window function")));
 
+	/*
+	 * Deal with cases where both base and offset are infinite, and computing
+	 * base +/- offset would cause an error.  As for float and numeric types,
+	 * we assume that all values infinitely precede +infinity and infinitely
+	 * follow -infinity.  See in_range_float8_float8() for reasoning.
+	 */
+	if (INTERVAL_IS_NOEND(offset) &&
+		(sub ? INTERVAL_IS_NOEND(base) : INTERVAL_IS_NOBEGIN(base)))
+		PG_RETURN_BOOL(true);
+
 	/* We don't currently bother to avoid overflow hazards here */
 	if (sub)
 		sum = DatumGetIntervalP(DirectFunctionCall2(interval_mi,
@@ -3848,21 +3863,13 @@ makeIntervalAggState(FunctionCallInfo fcinfo)
 }
 
 /*
- * Functions to add or subtract two finite intervals.
+ * Functions to add or subtract finite intervals.
  *
- * We handle non-finite intervals in different ways when accumulating/discarding
- * intervals and in actual mathematical operations respectively. But the
- * addition or subtraction of finite intervals have same implementation
- * respectively in both these cases.
- *
- * Addition/Subtraction of span1 and span2 is stored in the result. It is fine
- * to pass either of span1 or span2 as a result pointer. In such a case result
- * will overwrite the given value.
- *
- * If the result is not a valid interval, the function throws an error.
+ * These are used for normal arithmetic and aggregation of finite intervals
+ * only.  Non-finite intervals require special handling.
  */
 static void
-finite_interval_pl(Interval *result, Interval *span1, Interval *span2)
+finite_interval_pl(const Interval *span1, const Interval *span2, Interval *result)
 {
 	Assert(!INTERVAL_NOT_FINITE(span1));
 	Assert(!INTERVAL_NOT_FINITE(span2));
@@ -3889,7 +3896,7 @@ finite_interval_pl(Interval *result, Interval *span1, Interval *span2)
 }
 
 static void
-finite_interval_mi(Interval *result, Interval *span1, Interval *span2)
+finite_interval_mi(const Interval *span1, const Interval *span2, Interval *result)
 {
 	Assert(!INTERVAL_NOT_FINITE(span1));
 	Assert(!INTERVAL_NOT_FINITE(span2));
@@ -3921,26 +3928,56 @@ finite_interval_mi(Interval *result, Interval *span1, Interval *span2)
 static void
 do_interval_accum(IntervalAggState *state, Interval *newval)
 {
-	/* Count -infinity inputs separately from all else */
+	/* Infinite inputs are counted separately, and do not affect "N" */
 	if (INTERVAL_IS_NOBEGIN(newval))
 	{
 		state->nInfcount++;
 		return;
 	}
 
-	/* Count infinity inputs separately from all else */
 	if (INTERVAL_IS_NOEND(newval))
 	{
 		state->pInfcount++;
 		return;
 	}
 
-	finite_interval_pl(&state->sumX, &state->sumX, newval);
+	finite_interval_pl(&state->sumX, newval, &state->sumX);
 	state->N++;
 }
 
 /*
- * Transition function for interval aggregates.
+ * Remove the given interval value from the aggregated state.
+ */
+static void
+do_interval_discard(IntervalAggState *state, Interval *newval)
+{
+	/* Infinite inputs are counted separately, and do not affect "N" */
+	if (INTERVAL_IS_NOBEGIN(newval))
+	{
+		state->nInfcount--;
+		return;
+	}
+
+	if (INTERVAL_IS_NOEND(newval))
+	{
+		state->pInfcount--;
+		return;
+	}
+
+	/* Handle to be discarded finite value. */
+	state->N--;
+	if (state->N > 0)
+		finite_interval_mi(&state->sumX, newval, &state->sumX);
+	else
+	{
+		/* All values discarded, reset the state */
+		Assert(state->N == 0);
+		memset(&state->sumX, 0, sizeof(state->sumX));
+	}
+}
+
+/*
+ * Transition function for sum() and avg() interval aggregates.
  */
 Datum
 interval_avg_accum(PG_FUNCTION_ARGS)
@@ -3960,10 +3997,10 @@ interval_avg_accum(PG_FUNCTION_ARGS)
 }
 
 /*
- * Combine function for interval aggregates.
+ * Combine function for sum() and avg() interval aggregates.
  *
- * Combine the given internal aggregate states and place the combination in the
- * first argument.
+ * Combine the given internal aggregate states and place the combination in
+ * the first argument.
  */
 Datum
 interval_avg_combine(PG_FUNCTION_ARGS)
@@ -3999,7 +4036,7 @@ interval_avg_combine(PG_FUNCTION_ARGS)
 
 	/* Accumulate finite interval values, if any. */
 	if (state2->N > 0)
-		finite_interval_pl(&state1->sumX, &state1->sumX, &state2->sumX);
+		finite_interval_pl(&state1->sumX, &state2->sumX, &state1->sumX);
 
 	PG_RETURN_POINTER(state1);
 }
@@ -4019,20 +4056,26 @@ interval_avg_serialize(PG_FUNCTION_ARGS)
 	if (!AggCheckCallContext(fcinfo, NULL))
 		elog(ERROR, "aggregate function called in non-aggregate context");
 
-	/* TODO: Handle NULL inputs? */
 	state = (IntervalAggState *) PG_GETARG_POINTER(0);
+
 	pq_begintypsend(&buf);
+
 	/* N */
 	pq_sendint64(&buf, state->N);
-	/* Finite interval value */
+
+	/* sumX */
 	pq_sendint64(&buf, state->sumX.time);
 	pq_sendint32(&buf, state->sumX.day);
 	pq_sendint32(&buf, state->sumX.month);
+
 	/* pInfcount */
 	pq_sendint64(&buf, state->pInfcount);
+
 	/* nInfcount */
 	pq_sendint64(&buf, state->nInfcount);
+
 	result = pq_endtypsend(&buf);
+
 	PG_RETURN_BYTEA_P(result);
 }
 
@@ -4064,10 +4107,10 @@ interval_avg_deserialize(PG_FUNCTION_ARGS)
 	/* N */
 	result->N = pq_getmsgint64(&buf);
 
-	/* Interval struct elements, one by one. */
+	/* sumX */
 	result->sumX.time = pq_getmsgint64(&buf);
-	result->sumX.day = pq_getmsgint(&buf, sizeof(result->sumX.day));
-	result->sumX.month = pq_getmsgint(&buf, sizeof(result->sumX.month));
+	result->sumX.day = pq_getmsgint(&buf, 4);
+	result->sumX.month = pq_getmsgint(&buf, 4);
 
 	/* pInfcount */
 	result->pInfcount = pq_getmsgint64(&buf);
@@ -4081,42 +4124,10 @@ interval_avg_deserialize(PG_FUNCTION_ARGS)
 }
 
 /*
- * Remove the given interval value from the aggregated state.
- */
-static void
-do_interval_discard(IntervalAggState *state, Interval *newval)
-{
-	/* Count -infinity inputs separately from all else */
-	if (INTERVAL_IS_NOBEGIN(newval))
-	{
-		state->nInfcount--;
-		return;
-	}
-
-	/* Count infinity inputs separately from all else */
-	if (INTERVAL_IS_NOEND(newval))
-	{
-		state->pInfcount--;
-		return;
-	}
-
-	/* Handle to be discarded finite value. */
-	state->N--;
-	if (state->N > 0)
-		finite_interval_mi(&state->sumX, &state->sumX, newval);
-	else
-	{
-		/* All values discarded, reset the state */
-		Assert(state->N == 0);
-		memset(&state->sumX, 0, sizeof(state->sumX));
-	}
-}
-
-/*
- * Generic inverse transition function for interval aggregates
+ * Inverse transition function for sum() and avg() interval aggregates.
  */
 Datum
-interval_accum_inv(PG_FUNCTION_ARGS)
+interval_avg_accum_inv(PG_FUNCTION_ARGS)
 {
 	IntervalAggState *state;
 
@@ -4124,7 +4135,7 @@ interval_accum_inv(PG_FUNCTION_ARGS)
 
 	/* Should not get here with no state */
 	if (state == NULL)
-		elog(ERROR, "interval_accum_inv called with NULL state");
+		elog(ERROR, "interval_avg_accum_inv called with NULL state");
 
 	if (!PG_ARGISNULL(1))
 		do_interval_discard(state, PG_GETARG_INTERVAL_P(1));
@@ -4137,38 +4148,39 @@ Datum
 interval_avg(PG_FUNCTION_ARGS)
 {
 	IntervalAggState *state;
-	double		N_datum;
-	Interval   *sumX;
 
-	sumX = (Interval *) palloc(sizeof(Interval));
 	state = PG_ARGISNULL(0) ? NULL : (IntervalAggState *) PG_GETARG_POINTER(0);
 
+	/* If there were no non-null inputs, return NULL */
 	if (state == NULL || IA_TOTAL_COUNT(state) == 0)
 		PG_RETURN_NULL();
 
-	/* adding plus and minus infinities gives error */
-	if (state->pInfcount > 0 && state->nInfcount > 0)
-		ereport(ERROR,
-				(errcode(ERRCODE_DATETIME_VALUE_OUT_OF_RANGE),
-				 errmsg("interval out of range.")));
-
-	if (state->pInfcount > 0)
+	/*
+	 * Aggregating infinities that all have the same sign produces infinity
+	 * with that sign.  Aggregating infinities with different signs results in
+	 * an error.
+	 */
+	if (state->pInfcount > 0 || state->nInfcount > 0)
 	{
-		INTERVAL_NOEND(sumX);
-		PG_RETURN_INTERVAL_P(sumX);
-	}
+		Interval   *result;
 
-	if (state->nInfcount > 0)
-	{
-		INTERVAL_NOBEGIN(sumX);
-		PG_RETURN_INTERVAL_P(sumX);
-	}
+		if (state->pInfcount > 0 && state->nInfcount > 0)
+			ereport(ERROR,
+					(errcode(ERRCODE_DATETIME_VALUE_OUT_OF_RANGE),
+					 errmsg("interval out of range.")));
+
+		result = (Interval *) palloc(sizeof(Interval));
+		if (state->pInfcount > 0)
+			INTERVAL_NOEND(result);
+		else
+			INTERVAL_NOBEGIN(result);
 
-	N_datum = (double) state->N;
-	sumX = &state->sumX;
+		PG_RETURN_INTERVAL_P(result);
+	}
 
-	PG_RETURN_DATUM(DirectFunctionCall2(interval_div, IntervalPGetDatum(sumX),
-										Float8GetDatum(N_datum)));
+	return DirectFunctionCall2(interval_div,
+							   IntervalPGetDatum(&state->sumX),
+							   Float8GetDatum((double) state->N));
 }
 
 /* sum(interval) aggregate final function */
@@ -4178,33 +4190,31 @@ interval_sum(PG_FUNCTION_ARGS)
 	IntervalAggState *state;
 	Interval   *result;
 
-	result = (Interval *) palloc(sizeof(Interval));
-
 	state = PG_ARGISNULL(0) ? NULL : (IntervalAggState *) PG_GETARG_POINTER(0);
 
 	/* If there were no non-null inputs, return NULL */
 	if (state == NULL || IA_TOTAL_COUNT(state) == 0)
 		PG_RETURN_NULL();
 
-	/* adding plus and minus interval infinities is not possible */
+	/*
+	 * Aggregating infinities that all have the same sign produces infinity
+	 * with that sign.  Aggregating infinities with different signs results in
+	 * an error.
+	 */
 	if (state->pInfcount > 0 && state->nInfcount > 0)
 		ereport(ERROR,
 				(errcode(ERRCODE_DATETIME_VALUE_OUT_OF_RANGE),
 				 errmsg("interval out of range.")));
 
+	result = (Interval *) palloc(sizeof(Interval));
+
 	if (state->pInfcount > 0)
-	{
 		INTERVAL_NOEND(result);
-		PG_RETURN_INTERVAL_P(result);
-	}
-
-	if (state->nInfcount > 0)
-	{
+	else if (state->nInfcount > 0)
 		INTERVAL_NOBEGIN(result);
-		PG_RETURN_INTERVAL_P(result);
-	}
+	else
+		memcpy(result, &state->sumX, sizeof(Interval));
 
-	memcpy(result, &state->sumX, sizeof(Interval));
 	PG_RETURN_INTERVAL_P(result);
 }
 
@@ -4234,14 +4244,14 @@ timestamp_age(PG_FUNCTION_ARGS)
 	/*
 	 * Subtracting two infinite timestamps with different signs results in an
 	 * infinite interval with the same sign as the left operand. Subtracting
-	 * two infinte timestamps with the same sign results in an error.
+	 * two infinite timestamps with the same sign results in an error.
 	 */
 	if (TIMESTAMP_IS_NOBEGIN(dt1))
 	{
 		if (TIMESTAMP_IS_NOBEGIN(dt2))
 			ereport(ERROR,
 					(errcode(ERRCODE_DATETIME_VALUE_OUT_OF_RANGE),
-					 errmsg("timestamp out of range")));
+					 errmsg("interval out of range")));
 		else
 			INTERVAL_NOBEGIN(result);
 	}
@@ -4250,7 +4260,7 @@ timestamp_age(PG_FUNCTION_ARGS)
 		if (TIMESTAMP_IS_NOEND(dt2))
 			ereport(ERROR,
 					(errcode(ERRCODE_DATETIME_VALUE_OUT_OF_RANGE),
-					 errmsg("timestamp out of range")));
+					 errmsg("interval out of range")));
 		else
 			INTERVAL_NOEND(result);
 	}
@@ -4381,14 +4391,14 @@ timestamptz_age(PG_FUNCTION_ARGS)
 	/*
 	 * Subtracting two infinite timestamps with different signs results in an
 	 * infinite interval with the same sign as the left operand. Subtracting
-	 * two infinte timestamps with the same sign results in an error.
+	 * two infinite timestamps with the same sign results in an error.
 	 */
 	if (TIMESTAMP_IS_NOBEGIN(dt1))
 	{
 		if (TIMESTAMP_IS_NOBEGIN(dt2))
 			ereport(ERROR,
 					(errcode(ERRCODE_DATETIME_VALUE_OUT_OF_RANGE),
-					 errmsg("timestamp out of range")));
+					 errmsg("interval out of range")));
 		else
 			INTERVAL_NOBEGIN(result);
 	}
@@ -4397,7 +4407,7 @@ timestamptz_age(PG_FUNCTION_ARGS)
 		if (TIMESTAMP_IS_NOEND(dt2))
 			ereport(ERROR,
 					(errcode(ERRCODE_DATETIME_VALUE_OUT_OF_RANGE),
-					 errmsg("timestamp out of range")));
+					 errmsg("interval out of range")));
 		else
 			INTERVAL_NOEND(result);
 	}
@@ -5829,17 +5839,16 @@ extract_timestamptz(PG_FUNCTION_ARGS)
 /*
  * NonFiniteIntervalPart
  *
- *	Used by interval_part when extracting from infinite
- *	interval.  Returns +/-Infinity if that is the appropriate result,
- *	otherwise returns zero (which should be taken as meaning to return NULL).
+ *	Used by interval_part when extracting from infinite interval.  Returns
+ *	+/-Infinity if that is the appropriate result, otherwise returns zero
+ *	(which should be taken as meaning to return NULL).
  *
  *	Errors thrown here for invalid units should exactly match those that
  *	would be thrown in the calling functions, else there will be unexpected
  *	discrepancies between finite- and infinite-input cases.
  */
 static float8
-NonFiniteIntervalPart(int type, int unit, char *lowunits,
-					  bool isNegative, bool isTz)
+NonFiniteIntervalPart(int type, int unit, char *lowunits, bool isNegative)
 {
 	if ((type != UNITS) && (type != RESERV))
 		ereport(ERROR,
@@ -5906,8 +5915,7 @@ interval_part_common(PG_FUNCTION_ARGS, bool retnumeric)
 	if (INTERVAL_NOT_FINITE(interval))
 	{
 		double		r = NonFiniteIntervalPart(type, val, lowunits,
-											  INTERVAL_IS_NOBEGIN(interval),
-											  false);
+											  INTERVAL_IS_NOBEGIN(interval));
 
 		if (r != 0.0)
 		{
@@ -6453,7 +6461,6 @@ generate_series_timestamp(PG_FUNCTION_ARGS)
 		Timestamp	finish = PG_GETARG_TIMESTAMP(1);
 		Interval   *step = PG_GETARG_INTERVAL_P(2);
 		MemoryContext oldcontext;
-		const Interval interval_zero = {0};
 
 		/* create a function context for cross-call persistence */
 		funcctx = SRF_FIRSTCALL_INIT();
@@ -6476,7 +6483,7 @@ generate_series_timestamp(PG_FUNCTION_ARGS)
 		fctx->step = *step;
 
 		/* Determine sign of the interval */
-		fctx->step_sign = interval_cmp_internal(&fctx->step, &interval_zero);
+		fctx->step_sign = interval_sign(&fctx->step);
 
 		if (fctx->step_sign == 0)
 			ereport(ERROR,
@@ -6539,7 +6546,6 @@ generate_series_timestamptz_internal(FunctionCallInfo fcinfo)
 		Interval   *step = PG_GETARG_INTERVAL_P(2);
 		text	   *zone = (PG_NARGS() == 4) ? PG_GETARG_TEXT_PP(3) : NULL;
 		MemoryContext oldcontext;
-		const Interval interval_zero = {0};
 
 		/* create a function context for cross-call persistence */
 		funcctx = SRF_FIRSTCALL_INIT();
@@ -6563,7 +6569,7 @@ generate_series_timestamptz_internal(FunctionCallInfo fcinfo)
 		fctx->attimezone = zone ? lookup_timezone(zone) : session_timezone;
 
 		/* Determine sign of the interval */
-		fctx->step_sign = interval_cmp_internal(&fctx->step, &interval_zero);
+		fctx->step_sign = interval_sign(&fctx->step);
 
 		if (fctx->step_sign == 0)
 			ereport(ERROR,
diff --git a/src/include/datatype/timestamp.h b/src/include/datatype/timestamp.h
index f9bd30d225..b63acc0a2f 100644
--- a/src/include/datatype/timestamp.h
+++ b/src/include/datatype/timestamp.h
@@ -151,7 +151,7 @@ struct pg_itm_in
 #define TIMESTAMP_INFINITY	PG_INT64_MAX
 
 /*
- * Historically these alias for infinity have been used.
+ * Historically these aliases for infinity have been used.
  */
 #define DT_NOBEGIN		TIMESTAMP_MINUS_INFINITY
 #define DT_NOEND		TIMESTAMP_INFINITY
@@ -168,23 +168,29 @@ struct pg_itm_in
 
 #define TIMESTAMP_NOT_FINITE(j) (TIMESTAMP_IS_NOBEGIN(j) || TIMESTAMP_IS_NOEND(j))
 
+/*
+ * Infinite intervals are represented by setting all fields to the minimum or
+ * maximum integer values.
+ */
 #define INTERVAL_NOBEGIN(i)	\
 	do {	\
-		(i->time) = PG_INT64_MIN;	\
-		(i->day) = PG_INT32_MIN;	\
-		(i->month) = PG_INT32_MIN;	\
+		(i)->time = PG_INT64_MIN;	\
+		(i)->day = PG_INT32_MIN;	\
+		(i)->month = PG_INT32_MIN;	\
 	} while (0)
 
-#define INTERVAL_IS_NOBEGIN(i) ((i->month) == PG_INT32_MIN)
+#define INTERVAL_IS_NOBEGIN(i)	\
+	((i)->month == PG_INT32_MIN && (i)->day == PG_INT32_MIN && (i)->time == PG_INT64_MIN)
 
 #define INTERVAL_NOEND(i)	\
 	do {	\
-		(i->time) = PG_INT64_MAX;	\
-		(i->day) = PG_INT32_MAX;	\
-		(i->month) = PG_INT32_MAX;	\
+		(i)->time = PG_INT64_MAX;	\
+		(i)->day = PG_INT32_MAX;	\
+		(i)->month = PG_INT32_MAX;	\
 	} while (0)
 
-#define INTERVAL_IS_NOEND(i) ((i->month) == PG_INT32_MAX)
+#define INTERVAL_IS_NOEND(i)	\
+	((i)->month == PG_INT32_MAX && (i)->day == PG_INT32_MAX && (i)->time == PG_INT64_MAX)
 
 #define INTERVAL_NOT_FINITE(i) (INTERVAL_IS_NOBEGIN(i) || INTERVAL_IS_NOEND(i))
 
diff --git a/src/include/utils/timestamp.h b/src/include/utils/timestamp.h
index fe713fb6dd..c4dd96c8c9 100644
--- a/src/include/utils/timestamp.h
+++ b/src/include/utils/timestamp.h
@@ -118,7 +118,6 @@ extern int	timestamp2tm(Timestamp dt, int *tzp, struct pg_tm *tm,
 						 fsec_t *fsec, const char **tzn, pg_tz *attimezone);
 extern void dt2time(Timestamp jd, int *hour, int *min, int *sec, fsec_t *fsec);
 
-extern void EncodeSpecialInterval(Interval *interval, char *str);
 extern void interval2itm(Interval span, struct pg_itm *itm);
 extern int	itm2interval(struct pg_itm *itm, Interval *span);
 extern int	itmin2interval(struct pg_itm_in *itm_in, Interval *span);
@@ -128,8 +127,6 @@ extern void GetEpochTime(struct pg_tm *tm);
 
 extern int	timestamp_cmp_internal(Timestamp dt1, Timestamp dt2);
 
-extern double interval2timestamp_no_overflow(Interval *interval);
-
 /* timestamp comparison works for timestamptz also */
 #define timestamptz_cmp_internal(dt1,dt2)	timestamp_cmp_internal(dt1, dt2)
 
